/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.voxelisation.output;

import fr.amap.lidar.amapvox.voxelisation.Voxelization;
import fr.amap.lidar.amapvox.voxelisation.configuration.VoxelizationCfg;
import fr.amap.lidar.amapvox.voxelisation.configuration.params.VoxelParameters;
import java.io.File;
import java.io.IOException;
import org.apache.log4j.Logger;

/**
 *
 * @author pverley
 */
public abstract class AbstractOutput {
    
    protected final static Logger LOGGER = Logger.getLogger(AbstractOutput.class);
    
    protected final Voxelization voxelisation;
    protected final VoxelizationCfg voxCfg;
    protected final VoxelParameters voxParam;
    
    AbstractOutput(Voxelization voxelisation) {
        this.voxelisation = voxelisation;
        this.voxCfg = voxelisation.getVoxelizationCfg();
        this.voxParam = voxelisation.getVoxelParameters();
    }
    
    void progress(String progressMsg, long progress, long max) {
        voxelisation.fireProgress(progressMsg, progress, max);
    }
    
    abstract public File[] write() throws IOException;
    
}
